import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
import subprocess
import daemon

from datetime import datetime

def put_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        conn.commit()
        cur.close()
        conn.close()
        #print 'put_sql succeeded'
        return True
    except:
        #print 'put_sql failed'
        return False

def get_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        result = cur.fetchall()
        cur.close()
        conn.close()
        #print 'get_sql succeeded'
        return result
    except:
        #print 'get_sql failed'
        return None

def delete_table_data(table):
    return put_sql("DELETE FROM " + table + ";")

def get_table_data(table):
    return get_sql("SELECT * FROM " + table + ";")

def add_new_team_login(team_name, team_password):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        result_sql = put_sql("INSERT INTO login (team_name,team_password) VALUES ('%s','%s');" % (team_name,team_password,))
        if result_sql:
            print 'Added new team = ' + team_name + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql
    else:
        print 'Team = ' + team_name + ' login already exists'
        return False
        
def add_new_team_contact(team_name, contact_name, contact_email, contact_affiliation):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        result = get_sql("SELECT * FROM contacts WHERE team_name='" + team_name + "' AND contact_name='"+contact_name+"';")
        if result!=[]:
            print 'Name = ' + contact_name + ' already exists.'
            return False
        else:
            result_sql = put_sql("INSERT INTO contacts (team_name,contact_name,contact_email,contact_affiliation) VALUES ('%s','%s','%s','%s');" % (team_name,contact_name,contact_email,contact_affiliation,))
            if result_sql:
                print 'Added new team contact = ' + contact_name + '.'
            else:
                print 'Failed to add new team contact = ' + contact_name + '.'
            return result_sql

def add_new_team_score(team_name, score1, score2, interval_seconds):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        dt = datetime.now()
        result_sql = get_sql("SELECT time_stamp FROM scores WHERE team_name='" + team_name + "' ORDER BY time_stamp DESC LIMIT 1;")
        if result_sql != []:
            diff = (dt-result_sql[0][0]).total_seconds()
            if diff < interval_seconds:
                print 'Not enough time has elapsed since last submission.'
                return diff
        result_sql = put_sql("INSERT INTO scores (team_name,time_stamp,score1, score2) VALUES ('%s','%s',%s,%s);" % (team_name,dt,score1,score2,))
        if result_sql:
            print 'Added new team score = ' + str(score1) + ',' + str(score2) + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql

def get_user_password_dict():
    result_sql = get_sql("SELECT team_name,team_password FROM login;")
    if result_sql==[]:
        return None
    else:
        return dict(result_sql)

class RootServerAdmin:
    @cherrypy.expose
    def index(self):
            return """<html><head>
</head>
<body>
  <h2>2017 PHM SOCIETY DATA CHALLENGE ADMIN WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.<br><br>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
</body>
</html>
"""

class SecureServerAdmin:
    @cherrypy.expose
    def index(self):
        user_login = cherrypy.request.login
        return """<html><head></head><body>
<h2>Add a User</h2>
<form action="update" method="post" enctype="multipart/form-data">
Team name: <input type="text" name="Username" /><br/><br>
Password: <input type="text" name="Password" /><br/><br>
Contact name: <input type="text" name="contact_name" /><br/><br>
Contact affiliation: <input type="text" name="contact_affiliation" /><br/><br>
Contact email: <input type="text" name="contact_email" /><br/><br>
<input type="submit"/>
</form>
</html>"""

    @cherrypy.expose
    def update(self, Username, Password, contact_name,contact_affiliation,contact_email):
        x = add_new_team_login(Username,Password)
        if not x:
            return """<h2>User already exists</h2>"""
        x = add_new_team_contact(Username, contact_name, contact_email, contact_affiliation)
        if not x:
            return """<h2>New team created, but contact name already exists</h2>"""
        return """<h2>Success</h2>"""

if __name__ == '__main__':
    user_pass_list = {"admin":"ionmill!"}

    conf = {
        '/secure': {
            'tools.auth_digest.on': True,
            'tools.auth_digest.realm': '70.32.30.237:8095',
            'tools.auth_digest.get_ha1': auth_digest.get_ha1_dict_plain(user_pass_list),
            'tools.auth_digest.key': 'f433b27146791afa'
            }
        }

    root = RootServerAdmin()
    root.secure = SecureServerAdmin()

    cherrypy.config.update({'server.socket_host':'70.32.30.237'})
    cherrypy.config.update({'server.socket_port':8095})

    with daemon.DaemonContext():
        cherrypy.quickstart(root,'/',conf)
    
