import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
from os import walk
import daemon
import tarfile
import zipfile
import shutil
import gc

from datetime import datetime

def put_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        conn.commit()
        cur.close()
        conn.close()
        print 'put_sql succeeded'
        return True
    except:
        print 'put_sql failed'
        return False

def get_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        result = cur.fetchall()
        cur.close()
        conn.close()
        print 'get_sql succeeded'
        return result
    except:
        print 'get_sql failed'
        return None

def delete_table_data(table):
    return put_sql("DELETE FROM " + table + ";")

def drop_table(table):
    return put_sql("DROP " + table + ";")

def get_table_data(table):
    return get_sql("SELECT * FROM " + table + ";")

def add_new_team_login(team_name, team_password):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        result_sql = put_sql("INSERT INTO login (team_name,team_password) VALUES ('%s','%s');" % (team_name,team_password,))
        if result_sql:
            print 'Added new team = ' + team_name + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql
    else:
        print 'Team = ' + team_name + ' login already exists'
        return False
        
def add_new_team_contact(team_name, contact_name, contact_email, contact_affiliation):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        result = get_sql("SELECT * FROM contacts WHERE team_name='" + team_name + "' AND contact_name='"+contact_name+"';")
        if result!=[]:
            print 'Name = ' + contact_name + ' already exists.'
            return False
        else:
            result_sql = put_sql("INSERT INTO contacts (team_name,contact_name,contact_email,contact_affiliation) VALUES ('%s','%s','%s','%s');" % (team_name,contact_name,contact_email,contact_affiliation,))
            if result_sql:
                print 'Added new team contact = ' + contact_name + '.'
            else:
                print 'Failed to add new team contact = ' + contact_name + '.'
            return result_sql

def add_new_team_score(team_name, score, interval_seconds):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        dt = datetime.now()
        result_sql = get_sql("SELECT time_stamp FROM scores WHERE team_name='" + team_name + "' ORDER BY time_stamp DESC LIMIT 1;")
        if result_sql != []:
            diff = (dt-result_sql[0][0]).total_seconds()
            if diff < interval_seconds:
                print 'Not enough time has elapsed since last submission.'
                return diff
        result_sql = put_sql("INSERT INTO scores (team_name,time_stamp,score) VALUES ('%s','%s',%s);" % (team_name,dt,score,))
        if result_sql:
            print 'Added new team score = ' + str(score) + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql

def get_user_password_dict():
    result_sql = get_sql("SELECT team_name,team_password FROM login;")
    if result_sql==None:
        return None
    else:
        return dict(result_sql)
try:
    drop_table('scores')
except:
    pass
try:
    drop_table('login')
except:
    pass
try:
    drop_table('contacts')
except:
    pass
put_sql('create table login (team_name varchar(50),team_password varchar(50))')
put_sql('create table contacts (team_name varchar(50),contact_name varchar(256),contact_email varchar(512),contact_affiliation varchar(512))')
put_sql('create table scores (team_name varchar(50),time_stamp timestamp,score real,score2 real,avg real)')

login = pd.read_csv('login.csv')
for i in range(0,len(login)):
    put_sql("insert into login (team_name,team_password) values ('%s','%s')" % (login.loc[i,'team_name'],login.loc[i,'team_password']))

contacts = pd.read_csv('contacts.csv')
for i in range(0,len(contacts)):
    put_sql("insert into contacts (team_name,contact_name,contact_email,contact_affiliation) values ('%s','%s','%s','%s')" % (contacts.loc[i,'team_name'],contacts.loc[i,'contact_name'],contacts.loc[i,'contact_email'],contacts.loc[i,'contact_affiliation']))

    
